<!DOCTYPE html>
<html lang="en" xmlns:th="http://www.thymeleaf.org" xmlns="http://www.w3.org/1999/html">

<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Registration</title>

    <!-- CSS -->
    <link rel="stylesheet" th:href="@{assets/css/main.css}">

    <!-- Favicon and touch icons -->
    <link rel="shortcut icon" th:href="${theme.faviconUrl} ?: @{assets/ico/favicon.ico}">

    <!-- Custom CSS -->
    <style th:if="${theme.css}" th:text="${theme.css}"></style>
    <style th:if="${theme.customCss}" th:text="${theme.customCss}"></style>

    <script th:if="${bot_detection_plugin == 'google-recaptcha-v3-am-bot-detection'}"
            th:src="${'https://www.google.com/recaptcha/api.js?render=' + bot_detection_configuration.siteKey}"></script>
</head>

<body>
<div class="container" th:if="${error == null && success == null}">
    <div class="header">
        <img class="logo" th:src="${theme.logoUrl} ?: @{assets/images/gravitee-logo.svg}">
        <div class="title">
            <span th:text="#{registration.title} + ' ' + ${client.name}"></span>
        </div>
        <div class="header-description">
            <label th:text="#{registration.description} + ' '" />
            <a th:href="${loginAction}" th:text="#{registration.sign.in}" />
        </div>
    </div>
    <div class="section">
        <form class="form" id="form" role="form" th:action="${action}" method="post">
            <div class="form-field short-section">
                <input class="input-field short" type="text" id="firstName" name="firstName" th:placeholder="#{registration.first.name.placeholder}" required/>
                <input class="input-field short" type="text" id="lastName" name="lastName" th:placeholder="#{registration.last.name.placeholder}" required/>
            </div>

            <div class="form-field">
                <input class="input-field" type="text" id="username" name="username" th:placeholder="#{registration.user.name}" required/>
            </div>

            <div class="form-field">
                <input class="input-field" type="email" id="email" name="email" th:placeholder="#{registration.email.placeholder}" required/>
            </div>

            <div class="form-field">
                <input class="input-field" type="password" id="password" name="password" th:placeholder="#{registration.password.placeholder}" required/>
                <button type="button" class="icon-button icon-input-field toggle-password">
                    <span class="icons primary">visibility_off</span>
                </button>
            </div>

            <div th:if="${passwordSettings != null}" id="passwordSettings" class="password-policy">
                <span
                        th:if="${passwordSettings.minLength != null || passwordSettings.includeNumbers || passwordSettings.includeSpecialCharacters
                        || passwordSettings.lettersInMixedCase || passwordSettings.maxConsecutiveLetters != null ||
                        passwordSettings.excludePasswordsInDictionary || passwordSettings.excludeUserProfileInfoInPassword}"
                        class="small-font grey" th:text="#{password.validation.label}"/>

                <span th:if="${passwordSettings.minLength != null}" id="minLength" class="invalid"><span th:text="#{password.minLength.before}" /> <span th:text="${passwordSettings.minLength}"/> <span th:text="#{password.minLength.after}"/></span>
                <span th:if="${passwordSettings.includeNumbers}" id="includeNumbers" class="invalid" th:text="#{password.include.numbers}" />
                <span th:if="${passwordSettings.includeSpecialCharacters}" id="includeSpecialChar" class="invalid" th:text="#{password.include.special.characters}" />
                <span th:if="${passwordSettings.lettersInMixedCase}" id="mixedCase" class="invalid" th:text="#{password.letters.mixed.cases}" />
                <span th:if="${passwordSettings.maxConsecutiveLetters != null}" id="maxConsecutiveLetters" class="valid" ><span th:text="#{password.max.consecutive.letters.before}" /> <span th:text="${passwordSettings.maxConsecutiveLetters}"/> <span th:text="#{password.max.consecutive.letters.after}" /></span>
                <span th:if="${passwordSettings.excludeUserProfileInfoInPassword}" id="excludeUserProfileInfoInPassword" class="invalid" th:text="#{password.exclude.user.info}"/>
                <span th:if="${passwordSettings.excludePasswordsInDictionary}" id="excludePasswordsInDictionary" class="black" th:text="#{password.exclude.common.passwords}"/>
            </div>

            <input type="hidden" th:name="${_csrf.parameterName}" th:value="${_csrf.token}"/>
            <input type="hidden" th:name="client_id" th:value="${param.client_id}"/>

            <input type="hidden" th:if="${bot_detection_plugin == 'google-recaptcha-v3-am-bot-detection'}"
                   th:id="${bot_detection_configuration.get('tokenParameterName')}"
                   th:name="${bot_detection_configuration.get('tokenParameterName')}" />

            <div class="item error-text" th:switch="${warning}" th:if="${warning}">
                <span th:case="invalid_password_value" th:text="#{registration.error.invalid.password}"/>
                <span th:case="invalid_user_information" th:text="#{registration.error.invalid.user}"/>
                <span th:case="invalid_email" th:text="#{registration.error.invalid.email}"/>
                <span th:case="*" th:text="#{registration.error.information.missing}"/>
            </div>

            <button type="submit" id="submitBtn" class="button primary" th:text="#{registration.button.submit}"></button>
        </form>
    </div>
</div>

<div class="container" th:if="${success}">
    <div class="header">
        <img class="logo" th:src="${theme.logoUrl} ?: @{assets/images/gravitee-logo.svg}">
        <div class="title">
            <span th:text="#{registration.success.title}"/>
        </div>
        <div class="header-description">
            <label th:text="#{registration.success.description}"/>
        </div>
    </div>
    <div class="section">
        <a th:href="${loginAction}"><span class="icons">arrow_back</span><span th:text="#{common.back.to.sign.in}"/></a>
    </div>
</div>

<div class="container" th:if="${error}">
    <div class="header">
        <img class="logo" th:src="${theme.logoUrl} ?: @{assets/images/gravitee-logo.svg}">
        <div class="title">
            <span th:text="#{registration.error.title}"/>
        </div>
        <div class="header-description">
            <span class="medium-font grey regular" th:text="#{registration.error.description}"/>
        </div>
    </div>
    <div class="item error-text">
        <span>
            <span class="error" th:text="#{registration.error.description.label}"></span>
            <small th:text="*{error_description}?: ${error}"></small>
        </span>
    </div>
</div>

<script th:src="@{assets/js/jquery-3.5.1.min.js}"></script>
<script th:inline="javascript" th:attr="nonce=${script_inline_nonce}">
    function refreshCSRFToken() {
        /*
        If browser back button was used,
        reload to refresh the CSRF token
        */
        window.onpageshow = function(event) {
            if (event.persisted) {
                window.location.reload();
            }
        };
    }

    $(document).ready(function (){

        refreshCSRFToken();

        $("#submitBtn").on('click', function (event){
            /*[# th:if="${bot_detection_plugin == 'google-recaptcha-v3-am-bot-detection'}"]*/
                event.preventDefault();
                grecaptcha.ready(function() {
                  grecaptcha.execute(/*[[${bot_detection_configuration.siteKey}]]*/, {action: 'submit'}).then(function(token) {
                    $("#"+ /*[[${bot_detection_configuration.get('tokenParameterName')}]]*/ "no-name").val(token);
                    $("#form").unbind('submit').submit();
                  });
                });
            /*[/]*/

        });

        $(".toggle-password").on("click", function () {
            const icon = $(this).find(".icons").first();
            const input = $(this).parent().find("input").first();
            icon.text() === "visibility" ? icon.text("visibility_off") : icon.text("visibility");
            input.attr("type") === "password" ? input.attr("type", "text") : input.attr("type", "password");
        });
    });

    const submitButton = document.getElementById("submitBtn");
    if(submitButton){
        submitButton.disabled = true;
        submitButton.classList.add("button-disabled");
    }

    const passwordSettings = /*[[${passwordSettings}]]*/ null;
</script>
<script th:if="${error == null && success == null}" th:src="@{assets/js/password-validation-v2.js}"></script>
</body>
</html>
